import java.util.*;

public class BetterHashStringSet {
    private List<List<String>> data;
    private int size;

    public BetterHashStringSet() {
        int capacity = 10;
        data = new ArrayList<>(capacity);
        for(int i = 0; i < capacity; i++){
            data.add(i, new LinkedList<>());
        }
    }
    
    public boolean contains(String s) {
        int index = hashIndex(s);
        return data.get(index).contains(s);
    }

    public void add(String s) {
        if (!contains(s)) {
            int index = hashIndex(s);
            data.get(index).add(s);
            size++;
        }
    }

    public void remove(String s) {
        if (contains(s)) {
            int index = hashIndex(s);
            data.get(index).remove(s);
            size--;
        }
    }

    private int hashIndex(String s) {
        int h = 0;
        for(int i = 0; i < s.length(); i++){
            h = 31*h + (int)s.charAt(i);
        }
        return h % data.size();
    }

    public int size() {
        return size;
    }

    public boolean isEmpty() {
        return size == 0;
    }

    public String toString() {
        return data.toString();
    }
}
